#!/usr/bin/python

# Turn an assembler file using the x: notation for temporary labels
# into one using labels of the tmpxxx variety. This requires turning
# references like 1f and 5b into references to the nearest label of
# that number.
# azz@josstix.demon.co.uk

import sys
import os
import string
import re

labels = {}

def main():
    print "; Converted using untemp.py"
    lines = sys.stdin.readlines()

    # A couple of handy regexps
    ex1 = re.compile(r"([0-9]+)(:.*)")
    ex2 = re.compile(r"(.*j[pr].*)([0-9]+[fb])(.*)")
    
    # First pass: find labels and add to the dictionary
    for n in range(len(lines)):
        s = lines[n]
        m = ex1.match(s)
        if m:
            num = string.atoi(m.group(1))
            labels[n] = num
            print "; Label " + str(num) + " found at " + str(n)

    # Second pass: process the file
    for n in range(len(lines)):
        s = lines[n]
        if labels.has_key(n):
            m = ex1.match(s)
            print "; Modifying label at " + str(n) + " from " + m.group(1) + " to tmp" + str(n)
            s = "tmp" + str(n) + m.group(2)
        m = ex2.match(s)
        if m:
            x = n
            aim = string.atoi(m.group(2)[:-1])
            if m.group(2)[-1]=='f':
                direction = 1
            else:
                direction = -1
            while not (labels.has_key(x) and labels[x]==aim):
                x = x + direction
            print "; Modifying reference at " + str(n) + " from " + m.group(2) + " to tmp" + str(x)
            s = m.group(1) + "tmp" + str(x) + m.group(3)
        print s[:-1]

main()
